// bslide -- jump panel
// (C)Copyright 2004, Yashiro Takeshi

#include <new>
#include <btron/file.h>
#include <tstring.h>
#include <bstdio.h>
#include "BSlideJumpPanel.h"
#include "Exceptions.h"

TC* BSlideJumpPanel::fnames = 0;
W BSlideJumpPanel::selection = 0;

W impl_BSlideJumpPanel(W pnid, W ino, W value)
{
  if (pnid == -1){
    // 
    if (BSlideJumpPanel::fnames != 0){
      cset_dat(pidstdpnl(1), (W)BSlideJumpPanel::fnames);
    }
    return -1;
  }
  else {
    // when wants to end, return non-minus value
    switch (ino){
    case 0:
      // 
      return -1;
    case -1:
      // 
      return -1;
    case -2:
      // ɽ
      return -1;
    case 1:
      // ¿̾륻쥯
      cget_val(pidstdpnl(1), sizeof(W), &BSlideJumpPanel::selection);
      return -1;
    case 2:
      // 󥻥
      return 0;
    case 3:
      // ǧ
      cget_val(pidstdpnl(1), sizeof(W), &BSlideJumpPanel::selection);
      return 1;
    };
  }
  return -1; // ѥͥư³
}

int BSlideJumpPanel::execute()
{
  return exstdpnl(panel_id, (FUNCP)impl_BSlideJumpPanel);
} 

void BSlideJumpPanel::setFileList(const LinkCollector& link)
{
  if (fnames != 0){
    return; // åץǡȤǤΤϰ˸
  }
  
  int max = link.size();
  
  // ǳݤ TC[] ϤʳǤϷ褷ƤʤΤ
  // (ʬɬ꡼)
  fnames = new(std::nothrow) TC[(L_FNM+2)*(max+1)];
  if (fnames == 0){
    throw BException((TC[]){TCS_ERROR_BADALLOC});
  }
  fnames[0] = TNULL;
  
  for (int i = 0; i < max; i++){
    TC name[L_FNM+2] = {MC_STR, TNULL};
    link.getName(&name[1], i);
    tc_strcat(fnames, name);
  }
}

