// bslide -- menu
// (C)Copyright 2004, Yashiro Takeshi

#ifndef BSLIDEMENU_H
#define BSLIDEMENU_H

#include <map>
#include <vector>
#include <basic.h>
#include <hmi.h>
#include <libapp.h>

typedef enum tag_BSlideMenuItem {
  MN_VOID,
  MN_FINISH, // λ
  MN_REDISP, // ɽ
  MN_GONEXT, // ؿʤ
  MN_GOBACK, // 
  MN_JUMP,   // 
  MN_WINDOW, // ɥ
  MN_GADGET, // ʪ
} BSlideMenuItem;

class BSlideMenu{

private:
  typedef std::map<int, BSlideMenuItem> MConvMap;
  MConvMap mcnv;
  W mid;
  
public:

	BSlideMenu();
	virtual ~BSlideMenu(){
    if (mid >= 0){
      mdel_men(mid);
    }
  }
  
  W getMenuID() const {
    return mid;
  }
  
  BSlideMenuItem getInternalID(int rid) const;
  W popupMenu(WEVENT *ev);
  //BSlideMenuItem selMenu(WEVENT *ev);
};

#endif // BSLIDEMENU_H
