// bslide -- main routine
// (C)Copyright 2004, Yashiro Takeshi

#include <basic.h>
#include <bstdio.h>
#include <bassert.h>
#include <btron/libapp.h>
#include <btron/vobj.h>
#include "tcsliteral.h"
#include "databox.h"
#include "BSlideWindow.h"
#include "Exceptions.h"
#include "errorpanel.h"

extern void release_fnames();

static LINK* getTargetLink(MESSAGE* msg)
{
  switch (msg->msg_type){
  case EXECREQ:
    if ((((M_EXECREQ*)msg)->mode & 0x0002) != 0) {
      // ʪưΤǧᡢȵưϰ۾ｪλ
      oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
      return 0;
    }
    return &(((M_EXECREQ*)msg)->lnk);
  case FUSENREQ: // 䵤Υץư
    oend_prc(((M_FUSENREQ*)msg)->vid, NULL, 0);
    return 0;
  case DISPREQ: // Ȥɽư
    oend_req(((M_DISPREQ*)msg)->vid, 1);
    return 0;
  case PASTEREQ: // ǡŽߵư
    oend_req(((M_PASTEREQ*)msg)->vid, 1);
    return 0;
  case TADREQ: // ȤTADǡư
    oend_req(((M_TADREQ*)msg)->vid, 1);
    return 0;
  default:
    return 0;
  }
  return 0;
}

extern "C" W MAIN(MESSAGE* msg)
{
  W retval = 0;
  
  LINK *link = getTargetLink(msg);
  if (link == 0){
    printf("MAIN: File Not Specified\n");
    return -1;
  }
  
  LINK self;
  prc_inf(0, PI_LINK, &self, sizeof(LINK));
  opendbox(&self, USER_DATA, 0x2000);
  getscreen();
  initstdpnl();
  
  // ư¹
  try {
    BSlideWindow window(link);
    window.display(true);
    osta_prc(((M_EXECREQ*)msg)->vid, window.getWindowID());
    window.run();
  }
  catch (BException& e){
    errorpanel(e.what());
    printf("ERROR: %S\n", e.what());
    retval = -1;
  }
  catch (...){
    printf("MAIN: Unexpected Error\n");
    retval = -1;
  }
  oend_prc(((M_EXECREQ*)msg)->vid, NULL, 0);
  closedbox();
  
  // return retval; ȤɤCPU㳰ˤʤäƤޤ
  ext_prc(retval);
}

