// bslide -- jump panel
// (C)Copyright 2004, Yashiro Takeshi

#ifndef BSLIDEJUMPPANEL_H
#define BSLIDEJUMPPANEL_H

#include <basic.h>
#include <btron/hmi.h>
#include <btron/libapp.h>
#include <vector>

#include "databox.h"
#include "LinkCollector.h"

class BSlideJumpPanel{
  friend W impl_BSlideJumpPanel(W pnid, W ino, W value);

private:
  W panel_id;
  static TC* fnames;
  static W selection;

public:
	BSlideJumpPanel() : panel_id(-1) {
    //fnames = 0;
    //selection = 0;
    panel_id = opnstdpnl(PNL_JUMPSLIDE, 0);
  }
	virtual ~BSlideJumpPanel(){
    if (panel_id >= 0){
      clsstdpnl();
      panel_id = -1;
    }
    //delete [] fnames;
  }
  static void setFileList(const LinkCollector& link);
  void invalidateFileList() const {
    if (BSlideJumpPanel::fnames != 0){
      cset_dat(pidstdpnl(1), (W)BSlideJumpPanel::fnames);
    }
    return;
  }
  void setSelection(int n){
    selection = n + 1;
    cset_val(pidstdpnl(1), sizeof(W), &selection);
  }
  int getSelection() const {
    cget_val(pidstdpnl(1), sizeof(W), &selection);
    return selection - 1;
  }
  int execute();
};

#endif // BSLIDEJUMPPANEL_H
