// bslide -- iteration of linked segments+records
// (C)Copyright 2004, Yashiro Takeshi

#ifndef LINKCOLLECTOR_H
#define LINKCOLLECTOR_H

#include <basic.h>
typedef UW COLOR; // <-- 줬ʤtad.hʸäƤ
#include <tad.h>
#include <btron/libapp.h>
#include <vector>
#include "Exceptions.h"
#include "OptionParser.h"

class LinkCollector{

private:
  LINK *parent;
  std::vector<LINK> linkobj;
  std::vector<VOBJSEG*> linkseg;
  OptionParser opts;
  SIZE orgsize;

  void readLinkRecords(W fd);
  void readLinkSegments(W fd);

public:
	LinkCollector(LINK *parent = 0);
	virtual ~LinkCollector(){
    for (int i = 0; i < linkseg.size(); i++){
      delete [] ((B*)linkseg[i]);
    }
  }
  
  int size() const {
    return linkobj.size();
  }
  void getName(TC* name, int n) const;
  void drawObject(GID gid, int n, const RECT& rect);
};

#endif // LINKCOLLECTOR_H
