// bslide -- error panel
// (C)Copyright 2004, Yashiro Takeshi

#include	<basic.h>
#include	<bstdlib.h>
#include	<tcode.h>
#include	<errcode.h>
#include	<btron/btron.h>
#include	<btron/dp.h>
#include	<btron/hmi.h>
#include	<btron/vobj.h>
#include	<btron/tip.h>
#include "tcsliteral.h"

extern DEV_SPEC SCREEN;

#define MAXITEMS  (1+10)  // Կ+1
#define MAXWIDTH  30      // 1Ԥκʸ
#define GAPH      24      // ѥͥκ;͵
#define GAPV      24      // ѥͥξ岼;͵
#define GAPSW     8       // ʸȥåδ֤;͵

// TCʸ򥨥顼ѥͥ˽Ϥ롣TK_NLǲԤǤ롣

void errorpanel(const TC *p)
{
	static	TC buf0[310];	// (30ʸ+TNULL) x 10
	static	TC ms0txt[] = {TCS_BTN_CONFIRM};
	static	SWSEL	ms0 = {
		MS_PARTS|P_DISP|P_EMPHAS,
		{{0, 0, 80, 24}},
		0,			                  // ߡ
		ms0txt
	};
	
	static	PNL_ITEM	pi0[MAXITEMS] = {
		{PARTS_ITEM, 0, {{0, 0, 0, 0}}, 0, 0, (H*)&ms0}
	};
  
	static	PANEL	pn0 = {
		4, 0x784, 0, {{0, 0, 0, 0}}, 1, 1, pi0
	};
	
	WEVENT	wev1;
	PNT	p0;
	TC	*q;
	W	maxw, y, i, pid0;
	
	maxw = 10;
	q = buf0;
 
	for (y=1; ((y < MAXITEMS)&&(p != NULL)); y++) {
	  // Կ³ã뤫p = NULLǥ롼æ
		pi0[y].itype = TEXT_ITEM;
		pi0[y].info = 0;
		pi0[y].desc = 0;
		pi0[y].dnum = 0;
		pi0[y].ptr = (H*)q;
		
		i = 0;
		for (;;) {
			switch (*(q++) = *(p++)) {
		  case	TNULL:
				p = NULL;
				break;
			case	TK_NL:
				q[-1] = TNULL;
				break;
			default:
				if ((++i) < MAXWIDTH)
					continue;
				*(q++) = TNULL;
				break;
			}
			break;
		}
    
		// i: ʸ
		pi0[y].ir.c.left = GAPH;
		pi0[y].ir.c.top = GAPV + 20 * (y - 1);
		pi0[y].ir.c.right = GAPH + 16 * i;
		pi0[y].ir.c.bottom = GAPV + 20 * (y - 1) + 16;
		
		if (maxw < i)
			maxw = i;
	}
	
	pn0.nitem = y;
	pn0.r.c.right = GAPH * 2 + 16 * maxw;
	pn0.r.c.bottom = GAPV * 2 + 20 * (y - 1) + GAPSW + ms0.r.c.bottom;
	pi0[0].ir.c.left = GAPH + (16 * maxw - ms0.r.c.right) / 2;
	pi0[0].ir.c.top = GAPV + 20 * (y - 1) + GAPSW;
	
	p0.x = (SCREEN.hpixels - pn0.r.c.right) / 2;
	p0.y = (SCREEN.vpixels - pn0.r.c.bottom) / 2;
	
	pid0 = pcre_pnl(&pn0, &p0);
  
	sig_buz(0);
	if (pid0 < 0) {
		pdsp_msg(buf0);
		return;
	}
	for (;;) {
		switch (pact_pnl(pid0, &wev1.e, &i)) {
			case	P_EVENT:
				if (wev1.s.type == EV_DEVICE)
					oprc_dev(&wev1.e, NULL, 0);
				continue;
			case	0x5001:
				break;
			default:
				if (i >= 0)
					continue;
		}
		break;
	}
 
	pdel_pnl(pid0);
	return;
}
